#!/bin/bash

# This checks "ls -t", using short file names


FDO=/tmp/original_list
FDS=/tmp/sorted_list

# Run directory /tmp/ttest is nuked here
cd /tmp
if [ -d ttest ] ; then
    rm -Rvf ttest
fi
mkdir ttest
cd ttest
A=0
goon=1

# Main loop
while [ 1 -eq $goon ] ; do
    FD=""
    FN=$(printf "%018x" $A)
    
    # Make random file into random directory
    while [ 7 -lt $(echo -n $FN | wc -c ) ] && [ 2000 -lt $RANDOM ] ; do
	OC=$(printf "%o" $((65 + ($RANDOM % 26) )))
	ND=$(printf "\\${OC}/")
	FN=$(echo $FN | sed -e 's/^..//' )
	FD="${FD}${ND}"
    done
    if [ ! -d ./${FD} ] ; then
	mkdir -p $FD
    fi
    touch ./${FD}/${FN}
    
    # Make random directories. This does actually not affect the outcome.
    DN="."
    SU=$A
    while [ 0 -lt $SU ] ; do
	DO=$(printf "%o" $((65 + ($SU % 26) )))
	DC=$(printf "\\${DO}/")
	SU=$(( $SU / 26))
	DN="${DN}/${DC}"
    done
    if [ ! -d $DN ] ; then
	mkdir -p $DN
    else
	touch $DN
    fi
    
    #Comment-in the sleep-statement, and running time is 2 hrs.
    #Doing so would ensure different timestamps, even when working
    #with 1 s precision timestamps.
    #Does not seem to affect the outcome on my PC.
    #sleep 1
    A=$((A + 1))
    
    # Check the performance.
    find . -type f | xargs ls -tr | sed -e 's/^..............//' >$FDO
    cat $FDO | sort >$FDS
    if ! diff    $FDO $FDS ; then
	echo failure $A
	goon=0
    else
	echo "short: ${A} is OK."
    fi
    
done
