#!/bin/bash

# This test script makes rather long directory and filenames.

# Helper files
FDO=/tmp/flatbyls
FDS=/tmp/flatbycontent

# Test directory
cd /tmp
if [ -d     ftest ] ; then
    rm -Rvf ftest
fi
mkdir ftest
cd    ftest




# Main loop
goon=1
while [ 1 -eq $goon ] ; do

    #Here, the filename does not reveal age (still coded in content, too)
    FDIR="."
    Contents=$(printf "%018x" $A)

    FNAME="$(dd if=/dev/urandom bs=48 count=1 2>/dev/null | od -tx -An | awk '{gsub(" ",""); printf("%s",$0);}')"
    
    echo $Contents >${FDIR}/${FNAME}
    
    #If the error does not appear on your PC, increasing the sleep to 1 s
    #might (or might not) help.
    A=$((A+1))
    sleep 0.1

    if [ 2 -eq $((A % 5)) ] ; then
	
	# Check the performance of "ls -t" (every now and then
    
	# This should work
	find . -type f | xargs ls -tr >$FDO
	
	# The correct answer (hard way)
	for X in $(find . -type f) ; do
	    echo "$(cat $X) : ${X}"
	done | sort | sed -e 's/^.*: *//' >$FDS
	
	# Compare
	if ! diff    $FDO $FDS ; then
	    echo failure $A
	    goon=0
	else
	    echo "flat : ${A} is OK"
	fi
    else
	echo "flat : ${A}"
    fi
    
done
