#!/bin/bash

# This test script makes rather long directory and filenames.

# Helper files
FDO=/tmp/sqrtedbyls
FDS=/tmp/sqrtedbycontent

# Test directory
cd /tmp
if [ -d ltest ] ; then
    rm -Rvf ltest
fi
mkdir ltest
cd ltest



declare -a words
declare -a dirs
W=0
D=0
A=0

# Make a list of directory names. The "g" letter ensures that
# file names do not collide with directory names.
while [ 30 -ge $D ] ; do
    atom="$(dd if=/dev/urandom bs=14 count=1 | od -tx -An | sed -e 's/ //g')g$(dd if=/dev/urandom bs=16 count=1 | od -tx -An | sed -e 's/ //g')"
    dirs[D]=$atom
    D=$((D + 1))
done
echo "Dirs : $D"

# Main loop
goon=1
while [ 1 -eq $goon ] ; do

    #Here, the filename does not reveal age (still coded in content, too)
    FDIR="."
    Contents=$(printf "%018x" $A)
    
    #Put the files into random directory
    DD=0
    while [ 6 -gt $DD ] && [ 2000 -lt $RANDOM ] ; do
	SDIR=${dirs[$((RANDOM % $D))]}
	FDIR="${FDIR}/${SDIR}"
	DD=$((DD+1))
    done			   
    if [ ! -d ./${FDIR} ] ; then
	mkdir -p $FDIR
    fi

    
    FNAME="$(dd if=/dev/urandom bs=16 count=1 2>/dev/null | od -tx -An | sed -e 's/ //g')$(dd if=/dev/urandom bs=16 count=1 2>/dev/null | od -tx -An | sed -e 's/ //g')"

    echo $Contents >${FDIR}/${FNAME}
    
    #Making only one file per second -> different timestamps, also when
    #working with one-second precision.
    A=$((A+1))
    sleep 1
    
    # Check the performance of "ls -t"
    
    # This should work
    find . -type f | xargs ls -tr >$FDO
    
    # The correct answer (hard way)
    for X in $(find . -type f) ; do
	echo "$(cat $X) : ${X}"
    done | sort | sed -e 's/^.*: *//' >$FDS
    
    # Compare
    if ! diff    $FDO $FDS ; then
	echo failure $A
	goon=0
    else
	echo "long : ${A} is OK."
    fi
done
